﻿using System;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;

using System.Runtime.InteropServices;

namespace DesktopChange01
{
    public partial class MainForm : Form
    {
        [DllImport("user32.dll", CharSet = CharSet.Auto)]
        public static extern IntPtr FindWindow(string strClassName, int nptWindowName);
        [return: MarshalAs(UnmanagedType.Bool)]
        [DllImport("user32.dll", SetLastError = true)]
        public static extern bool PostMessage(HandleRef hWnd, UInt32 Msg, IntPtr wParam, IntPtr lParam);

        public MainForm()
        {
            InitializeComponent();
        }

        private void getPath()
        {
            textBox1.Text = RegData.getUserDesktopPath();
            textBox2.Text = RegData.getAllUsersDesktopPath();

        }

        private void killExplorer()
        {
            ProcessStartInfo taskKill = new ProcessStartInfo("taskkill", "/F /IM explorer.exe");
            taskKill.WindowStyle = ProcessWindowStyle.Hidden;
            Process process = new Process();
            process.StartInfo = taskKill;
            process.Start();
            process.WaitForExit();
        }

        /*private void killExplorer()
        {
            IntPtr p = FindWindow("Progman", 0);
            PostMessage(new HandleRef(null, p), 0x0012, new IntPtr(0), new IntPtr(0));
        }*/

        private void startexplorer()
        {
            Process.Start("explorer.exe");
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Apply Changes?\n\nExplorer will be Restarted!!!", "Confirmation", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1) == DialogResult.Yes)
            {
                if (!RegData.setUserDesktopPath(textBox1.Text))
                {
                    MessageBox.Show("Wrong Path For \"User's Desktop\"", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    textBox1.Text = RegData.getUserDesktopPath();
                }
                
                //restart Explorer
                killExplorer();
                startexplorer();
            }else{
                getPath();
            }
        }

        private void MainForm_Shown(object sender, EventArgs e)
        {
            getPath();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (folderBrowserDialog1.ShowDialog() == DialogResult.OK)
            {
                textBox1.Text = folderBrowserDialog1.SelectedPath;
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (folderBrowserDialog1.ShowDialog() == DialogResult.OK)
            {
                textBox2.Text = folderBrowserDialog1.SelectedPath;
            }
        }

        private void button5_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Reset to current directory?", "Reset", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1) == DialogResult.Yes)
            {
                textBox1.Text = RegData.getUserDesktopPath();
            }
        }

        private void button6_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Reset to current directory?", "Reset", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1) == DialogResult.Yes)
            {
                textBox2.Text = RegData.getAllUsersDesktopPath();
            }
        }

        private void button7_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Apply Changes?\n\nExplorer will be Restarted!!!", "Confirmation", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1) == DialogResult.Yes)
            {
                if (!RegData.setAllUsersDesktopPath(textBox2.Text))
                {
                    MessageBox.Show("Wrong Path For \"All User's Desktop\"", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    textBox2.Text = RegData.getAllUsersDesktopPath();
                }

                //restart Explorer
                killExplorer();
                startexplorer();
            }
            else
            {
                getPath();
            }
        }

    }
}
